.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib

; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc   PROTO : HWND, : UINT, : WPARAM, : LPARAM
WindowProc    PROTO : HWND, : UINT, : WPARAM, : LPARAM
CenterWindow PROTO : HWND, : DWORD,:DWORD
.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  		      equ 101
IDI_ICON              equ 200
IDC_EXIT              equ 102
IDC_WINDOWBUTTON      equ 103
IDC_WINDOW            equ 104

; Required data

.data
szTitle     db "Centering a window on another window", 0
szTitle2    db "Another window",0

.data?

hInstance HINSTANCE ?
hIcon     HICON     ?

.code

start:

INVOKE InitCommonControls

INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; --------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0

; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

 .IF uMsg == WM_INITDIALOG
 
  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  
    .ELSEIF uMsg == WM_COMMAND
     
       
      .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 
   .ENDIF 
  
    .IF wParam == IDC_EXIT 
      INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0

    .ENDIF
    
    .IF wParam == IDC_WINDOWBUTTON 

invoke DialogBoxParam,hInstance,IDC_WINDOW,hWnd,addr WindowProc,0
        

    .ENDIF

    xor eax,eax
  ret
DialogProc endp

; Window procedure                                   
;-------------------------------------------------------------------------------------------------
WindowProc proc  hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM



    mov		eax,uMsg
    .IF eax == WM_INITDIALOG
    INVOKE SetWindowText, hWnd, addr szTitle2
    Call CenterWindow
   ; invoke SetWindowPos,hWnd,HWND_TOPMOST,ecx,edx,0,0,SWP_NOMOVE + SWP_NOSIZE    

    .ELSEIF eax == WM_COMMAND
    mov		eax,wParam
	and		eax,0FFFFh

 .ELSEIF eax == WM_CLOSE 
    	INVOKE EndDialog, hWnd, 0
   .ENDIF 


    xor eax,eax
  ret                
WindowProc endp

CenterWindow PROC winHandle:HWND, winWidth:DWORD, winHeight:DWORD
LOCAL gpRect:RECT

INVOKE GetWindowRect, winHandle, ADDR gpRect

; Calculate X-position of window:
MOV EAX, gpRect.right
SUB EAX, gpRect.left
SUB EAX, winWidth
MOV ECX, EAX
AND ECX, 1 SHL 31 ;Mask for sign bit.
SHR EAX, 1 ;Quick-n-dirty IDIV / 2.
OR EAX, ECX ;Replace sign bit.
ADD EAX, gpRect.left
MOV ECX, EAX ;Stash x-pos.

; Calculate Y-position of window:
MOV EAX, gpRect.bottom
SUB EAX, gpRect.top
SUB EAX, winHeight
MOV EDX, EAX
AND EDX, 1 SHL 31
SHR EAX, 1
OR EAX, EDX
ADD EAX, gpRect.top
MOV EDX, EAX
RET

CenterWindow ENDP
end start